<template>

  <q-toolbar class="bg-primary text-white shadow-2" role="region" aria-label="Lijst header">
    <q-toolbar-title role="heading" aria-level="2">Rendering</q-toolbar-title>
    <q-checkbox name="compact" for="compact" v-model="compact" title="Verberg tussenkopjes" tabindex="0" dense
                dark label="compact" class="smaller"></q-checkbox>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="filter" v-model="search_value" tabindex="0" title="Filter lijst" autofocus>
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
        <template v-slot:append>
          <q-icon name="close" @click="search_value = ''" class="cursor-pointer"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>

  <div class="scroll_list" role="region" aria-label="Lijst presentatie-items (tabellen)">
    <q-list bordered v-if="presentation">
      <template v-if="presentation.concept && presentation.children.length < 1"></template>
      <q-item v-else>
        <div v-if="presentation.concept" class="text-h5">{{ show_label(presentation.concept) }}</div>
        <div v-else class="text-h5">{{ presentation.id }}</div>
      </q-item>

      <TocTreeItem
        v-for="tree_item in presentation.children"
        :level="1"
        :tree_item="tree_item"
        :key="tree_item.id"
        :search_value="search_value"
        :compact="compact">
      </TocTreeItem>
    </q-list>

    <q-inner-loading :showing="loading">
      <q-circular-progress
        v-if="loading"
        class="text-yellow"
        size="50px"
        indeterminate
        :thickness="0.22"></q-circular-progress>
    </q-inner-loading>
  </div>
</template>

<script>
import TocTreeItem from "components/TocTreeItem";
import SharedMethods from "components/SharedMethods";

export default {
  name: "TocTree",
  components: {TocTreeItem},
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.get_label
  },
  updated() {
    this.$nextTick(() => {
      this.scroll_to_active()
    })
  },
  props: {
    presentation: Object,
    loading: null
  },
  data() {
    return {
      search_value: undefined,
      compact: false,

    }
  },
  watch: {
    "$route.hash": function () {
      this.$nextTick(() => {
        this.scroll_to_active()
      })
    }
  },
  methods: {
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[1]
        if (el) {
          let offset = el.getBoundingClientRect().top - window.scrollY - 100
          if (offset > window.innerHeight || offset < 0) {
            this.$nextTick(() => {
                el.scrollIntoView(true)
              }
            )
          }
        }
      }
    }
  }
}
</script>

<style scoped>
.smaller {
  font-size: 12px;
}
.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}
</style>
